using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.SqlClient;


namespace Akadia.AutoIncrement
{
	public class AutoIncrement : System.Windows.Forms.Form
	{
		private System.Windows.Forms.DataGrid dgShowCat;
		private System.Windows.Forms.Label lblUpdate;
		private System.Windows.Forms.Button btnUpdate;
		private System.ComponentModel.Container components = null;

		private DataSet catDS;
		private SqlDataAdapter catDA;
		private System.Windows.Forms.TextBox txtCatName;

		public AutoIncrement()
		{
			// Initialize GUI
			InitializeComponent();

			// Fetch Categories Table into DataSet
			SqlConnection nwindConn = new SqlConnection("Data Source=XEON; " +
				"Initial Catalog=Northwind; User id=sa; Password=manager;");

			catDA = new SqlDataAdapter("SELECT CategoryID, "+
				"CategoryName FROM Categories ORDER BY CategoryID", nwindConn);

			catDA.InsertCommand = new SqlCommand("InsertCategory", nwindConn);
			catDA.InsertCommand.CommandType = CommandType.StoredProcedure;

			catDA.InsertCommand.Parameters.Add("@CategoryName",
				SqlDbType.NChar, 15, "CategoryName");

			SqlParameter myParm = catDA.InsertCommand.Parameters.Add(
                "@Identity", SqlDbType.Int, 0, "CategoryID");
			myParm.Direction = ParameterDirection.Output;

			nwindConn.Open();

			catDS = new DataSet("CategoriesDS");
			catDA.Fill(catDS, "Categories");
			dgShowCat.SetDataBinding(catDS,"Categories");

			nwindConn.Close();
		}

		// Update Dataset using the Stored Procedure and fetch
		// Autoincrement Value back to the Dataset
		private void btnUpdate_Click(object sender, System.EventArgs e)
		{
			DataRow newRow = catDS.Tables["Categories"].NewRow();
			newRow["CategoryName"] = txtCatName.Text;
			catDS.Tables["Categories"].Rows.Add(newRow);
			
			catDA.Update(catDS, "Categories");	
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.dgShowCat = new System.Windows.Forms.DataGrid();
			this.txtCatName = new System.Windows.Forms.TextBox();
			this.lblUpdate = new System.Windows.Forms.Label();
			this.btnUpdate = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.dgShowCat)).BeginInit();
			this.SuspendLayout();
			// 
			// dgShowCat
			// 
			this.dgShowCat.CaptionText = "Table Categories";
			this.dgShowCat.DataMember = "";
			this.dgShowCat.HeaderForeColor = System.Drawing.SystemColors.ControlText;
			this.dgShowCat.Location = new System.Drawing.Point(6, 5);
			this.dgShowCat.Name = "dgShowCat";
			this.dgShowCat.Size = new System.Drawing.Size(393, 200);
			this.dgShowCat.TabIndex = 0;
			// 
			// txtCatName
			// 
			this.txtCatName.Location = new System.Drawing.Point(90, 221);
			this.txtCatName.Name = "txtCatName";
			this.txtCatName.Size = new System.Drawing.Size(133, 20);
			this.txtCatName.TabIndex = 1;
			this.txtCatName.Text = "";
			// 
			// lblUpdate
			// 
			this.lblUpdate.Location = new System.Drawing.Point(0, 223);
			this.lblUpdate.Name = "lblUpdate";
			this.lblUpdate.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.lblUpdate.Size = new System.Drawing.Size(83, 15);
			this.lblUpdate.TabIndex = 2;
			this.lblUpdate.Text = "Category Name";
			// 
			// btnUpdate
			// 
			this.btnUpdate.Location = new System.Drawing.Point(230, 221);
			this.btnUpdate.Name = "btnUpdate";
			this.btnUpdate.Size = new System.Drawing.Size(75, 21);
			this.btnUpdate.TabIndex = 3;
			this.btnUpdate.Text = "Update";
			this.btnUpdate.Click += new System.EventHandler(this.btnUpdate_Click);
			// 
			// AutoIncrement
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(404, 255);
			this.Controls.Add(this.btnUpdate);
			this.Controls.Add(this.lblUpdate);
			this.Controls.Add(this.txtCatName);
			this.Controls.Add(this.dgShowCat);
			this.Name = "AutoIncrement";
			this.Text = "Return Autoincrement Primary Key in Data Set";
			((System.ComponentModel.ISupportInitialize)(this.dgShowCat)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new AutoIncrement());
		}
	}
}
